<div *ngIf="evaluatorModuleConfigurations" class="container">

  <div class="level">

    <div class="level-left">
      <div class="level-item">
        <h3 class="title is-3 has-text-centered has-text-grey-dark">Manage evaluator criterias</h3>
      </div>
    </div>

    <div *ngIf="!addPanelActive(); else backToEvaluationCriteriaList" class="level-right">
      <div class="level-item">
        <a class="button is-primary is-medium" (click)="activeAddPanel()">
          <span class="icon"><i class="fas fa-plus"></i></span>
          <span>Add criteria</span>
        </a>
      </div>
    </div>

    <ng-template #backToEvaluationCriteriaList>
      <div class="level-right">
        <div class="level-item">
          <a class="button is-primary is-medium" (click)="disactiveAddPanel()">
            <span class="icon"><i class="fas fa-arrow-left"></i></span>
            <span>Back to list</span>
          </a>
        </div>
      </div>
    </ng-template>

  </div>

  <hr>

  <div *ngIf="!addPanelActive(); else addPanelBloc" class="content">
    <div *ngFor="let criteria of evaluatorModuleConfigurations; let i = index" class="box">

      <div *ngIf="!isEditCriteriaActivate(criteria); else editCriteriaBloc">
        <h3 class="subtitle is-3">{{ criteria.label }}</h3>
        <h4 class="subtitle is-4">{{ criteria.description }}</h4>
        <h5 class="subtitle is-5">Weight : {{ criteria.value.weight }}</h5>

        <!--     Subcriterias Table   /-->
        <div class="table-container">

          <table class="table is-striped">
            <thead>
            <tr>
              <th>Weight</th>
              <th>Operator</th>
              <th>Data to evaluate</th>
              <th>Comparator</th>
              <th>Value</th>
            </tr>
            </thead>
            <tbody>
            <tr *ngFor="let sub of  criteria.value.subcriterias;  let j=index; let isFirst = first">
              <td>
                {{sub.weight}}
              </td>
              <td [innerHTML]='!isFirst ? criteria.value.operators[j - 1].type :""'>
              </td>
              <td>
                {{sub.key}}
              </td>
              <td>
                {{sub.compareSymbol}}
              </td>
              <td>
                {{sub.value}}
            </tr>
            </tbody>
          </table>
        </div>


        <p><b>Module evaluated : </b>{{ criteria.value.moduleName }}</p>

        <hr>

        <div class="buttons">
          <a class="button is-primary" (click)="activeEditCriteria(criteria)">
            <span class="icon"><i class="far fa-edit"></i></span>
            <span>Edit</span>
          </a>
          <a class="button is-danger" (click)="deleteEvaluatorCriteria(criteria)">
            <span class="icon"><i class="fas fa-trash-alt"></i></span>
            <span>Delete</span>
          </a>
        </div>
      </div>

      <ng-template #editCriteriaBloc>

        <h4 class="subtitle is-4">Module evaluated: {{ criteria.value.moduleName }}</h4>

        <div class="columns">

          <!-- NAME -->
          <div class="column is-2">
            <div class="field">
              <div class="control">
                <label class="label"
                       style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Name</label>
                <input class="input" type="text" [(ngModel)]="editCriteriaLabel">
              </div>
            </div>
          </div>
        </div>

        <div class="field">
          <div class="control">
            <label class="label">Description</label>
            <input class="input" type="text" [(ngModel)]="editCriteriaDescription">
          </div>
        </div>

        <!-- FIRST SUB CRITERIA -->
        <div class="columns">

          <!--      WEIGHT -->
          <div class="column is-2">
            <div class="field">
              <div class="control">
                <label class="label"
                       style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Weight</label>
                <input class="input" type="number" min="0" oninput="validity.valid||(value='');" name="weight"
                       [(ngModel)]="editCriteriaSubcriterias[0].weight">
              </div>
            </div>
          </div>

          <!-- OPERATOR -->
          <div class="column is-2">
          </div>

          <!-- KEY -->
          <div class="column is-2">
            <div class="field">
              <div class="control">
                <label class="label" style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Data to
                  evaluate</label>
                <div class="select">
                  <select [(ngModel)]="editCriteriaSubcriterias[0].key"
                          (ngModelChange)="dataKeyChange(criteria.value.moduleName, editCriteriaSubcriterias[0])">
                    <option *ngFor="let data of getModuleData(criteria.value.moduleName)" [ngValue]="data">
                      {{ data }}
                    </option>
                  </select>
                </div>
              </div>
            </div>
          </div>

          <!-- COMPARATOR -->
          <div *ngIf="editCriteriaSubcriterias[0].key.length > 0" class="column is-2">
            <div class="field">
              <div class="control">
                <label class="label"
                       style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Comparator</label>
                <div class="select">
                  <select [(ngModel)]="editCriteriaSubcriterias[0].compareSymbol">
                    <option
                      *ngFor="let comparator of getComparators(editCriteriaSubcriterias[0].key,criteria.value.moduleName)"
                      [ngValue]="comparator">
                      {{ comparator }}
                    </option>
                  </select>
                </div>
              </div>
            </div>
          </div>

          <!-- VALUE -->
          <div *ngIf="editCriteriaSubcriterias[0].key.length > 0" class="column is-2">
            <div class="field">
              <div class="control">

                <div [ngSwitch]="getDataType(editCriteriaSubcriterias[0].key, criteria.value.moduleName)"
                     class="field">

                  <div *ngSwitchCase="'number'">
                    <label class="label"
                           style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Value</label>
                    <input class="input" type="number" min="0" oninput="validity.valid||(value='');" name="criteriaValue"
                           [(ngModel)]="editCriteriaSubcriterias[0].value">
                  </div>

                  <div *ngSwitchCase="'boolean'">
                    <input [id]="editCriteriaSubcriterias[0].key" type="checkbox"
                           [name]="editCriteriaSubcriterias[0].key"
                           class="switch is-rounded is-primary form-control" checked
                           [(ngModel)]="editCriteriaSubcriterias[0].value">
                    <label for="{{ editCriteriaSubcriterias[0].key }}" class="label">Value</label>
                  </div>

                  <div *ngSwitchCase="'string'">
                    <label class="label">Value</label>
                    <input class="input" type="text" [(ngModel)]="editCriteriaSubcriterias[0].value">
                  </div>

                </div>

              </div>
            </div>

          </div>

          <!-- PLUS BUTTON -->
          <div
            *ngIf="editCriteriaSubcriterias[0].key.length > 0 && isLastSub(editCriteriaSubcriterias,editCriteriaSubcriterias[0])"
            class="column is-2">
            <label class="label"> <br/></label>

            <button [disabled]="addingAllowed(editCriteriaSubcriterias)" class="button is-success"
                    (click)="addSubCriteria(editCriteriaSubcriterias,editCriteriaOperators)"
            ><span class="icon"><i class="fas fa-plus"></i></span>
            </button>
          </div>
          <div class="column"
               *ngIf="!isLastSub(editCriteriaSubcriterias,editCriteriaSubcriterias[0])"></div>

        </div>

        <!-- END FIRST SUB CRITERIA -->


        <!--     TEMPLATE SUBCRITERIAS -->

        <div *ngFor="let sub of editCriteriaSubcriterias| slice:1;  let j=index" class="columns">
          <!--      WEIGHT -->
          <div class="column is-2">
            <div class="field">
              <div class="control">
                <label class="label"
                       style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Weight</label>
                <input class="input" type="number" min="0" oninput="validity.valid||(value='');" name="weight"
                       [(ngModel)]="sub.weight">
              </div>
            </div>
          </div>


          <!-- OPERATOR -->
          <div class="column is-2">
            <div class="field">
              <div class="control">
                <label class="label" style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Operator
                  Type</label>
                <div class="select">
                  <select [(ngModel)]="editCriteriaOperators[j].type">
                    <option value="AND">
                      AND
                    </option>
                    <option value="OR">
                      OR
                    </option>
                  </select>
                </div>
              </div>
            </div>
          </div>

          <!-- KEY -->
          <div *ngIf="editCriteriaOperators[j].type.length > 0" class="column is-2">
            <div class="field">
              <div class="control">
                <label class="label" style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Data to
                  evaluate</label>
                <div class="select">
                  <select [(ngModel)]="sub.key" (ngModelChange)="dataKeyChange(criteria.value.moduleName, sub)">
                    <option *ngFor="let data of getModuleData(criteria.value.moduleName)" [ngValue]="data">
                      {{ data }}
                    </option>
                  </select>
                </div>
              </div>
            </div>
          </div>

          <!--      EMPTY OPERATOR-->
          <div *ngIf="editCriteriaOperators[j].type.length == 0" class="column is-2">
          </div>


          <!-- COMPARATOR -->
          <div *ngIf="sub.key.length > 0" class="column is-2">
            <div class="field">
              <div class="control">
                <label class="label"
                       style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Comparator</label>
                <div class="select">
                  <select [(ngModel)]="sub.compareSymbol">
                    <option *ngFor="let comparator of getComparators(sub.key,criteria.value.moduleName)"
                            [ngValue]="comparator">
                      {{ comparator }}
                    </option>
                  </select>
                </div>
              </div>
            </div>
          </div>

          <!--      EMPTY OPERATOR-->
          <div *ngIf="sub.key.length == 0" class="column is-2">
          </div>

          <!-- VALUE -->
          <div *ngIf="sub.key.length > 0" class="column is-2">
            <div class="field">
              <div class="control">

                <div [ngSwitch]="getDataType(sub.key, criteria.value.moduleName)" class="field">

                  <div *ngSwitchCase="'number'">
                    <label class="label"
                           style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Value</label>
                    <input class="input" type="number" min="0" oninput="validity.valid||(value='');" name="criteriaValue"
                           [(ngModel)]="sub.value">
                  </div>

                  <div *ngSwitchCase="'boolean'">
                    <input [id]="sub.key" type="checkbox"
                           [name]="sub.key"
                           class="switch is-rounded is-primary form-control" checked
                           [(ngModel)]="sub.value">
                    <label for="{{ sub.key }}" class="label">Value</label>
                  </div>

                  <div *ngSwitchCase="'string'">
                    <label class="label">Value</label>
                    <input class="input" type="text" [(ngModel)]="sub.value">
                  </div>

                </div>

              </div>
            </div>

          </div>

          <!--      EMPTY OPERATOR-->
          <div *ngIf="sub.key.length == 0" class="column is-2">
          </div>

          <!-- MINUS BUTTON -->
          <div class="column is-1">
            <label class="label"> <br/></label>
            <button class="button is-danger"
                    (click)="removeSubCriteria(editCriteriaSubcriterias, editCriteriaOperators, editCriteriaSubcriterias.indexOf(sub))">
              <span class="icon"><i class="fas fa-minus"></i></span>
            </button>
          </div>

          <!-- PLUS BUTTON -->
          <div *ngIf="sub.key.length > 0 && isLastSub(editCriteriaSubcriterias,sub)" class="column is-1">
            <label class="label"> <br/></label>
            <button [disabled]="addingAllowed(editCriteriaSubcriterias)" class="button is-success"
                    (click)="addSubCriteria(editCriteriaSubcriterias,editCriteriaOperators)">
              <span class="icon"><i class="fas fa-plus"></i></span>
            </button>
          </div>

          <div class="column is-1" *ngIf="sub.key.length == 0"></div>

          <div class="column is-1" *ngIf="!isLastSub(editCriteriaSubcriterias,sub)"></div>
        </div>

        <!--              END EDIT-->
        <hr>


        <div class="buttons">
          <button class="button is-success"
                  [disabled]="addingAllowed(editCriteriaSubcriterias)"
                  (click)="updateEvaluatorCriteria()">
            <span class="icon"><i class="fas fa-check"></i></span>
            <span>Confirm</span>
          </button>
          <button class="button"
                  (click)="disactiveEditCriteria()">
            <span>Cancel</span>
          </button>
        </div>
      </ng-template>

    </div>
    <div *ngIf="evaluatorModuleConfigurations.length === 0" class="notification is-primary">
      No evaluation criteria
    </div>
  </div>

  <ng-template #addPanelBloc>
    <app-add-evaluation-criteria [currentWorkspace]="currentWorkspace"
                                 [evaluatorConfiguration]="evaluatorModuleConfigurations"></app-add-evaluation-criteria>
  </ng-template>

</div>
